
import java.awt.Button;
import java.awt.CardLayout;
import java.awt.Color;
import java.awt.Frame;
import java.awt.Panel;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;	

class MyCardLayOut extends Frame
{
	private final int ButtonCnt = 5;	//	버튼의 개수	
	private Panel []panel;				//	Panel의 개수 또한 버튼의 개수와 동일
	private Button []button;			//	각 버튼들을 Panel에 추가할 것이다.
	private CardLayout cardlayout;
	
	private Color color[] = {
			Color.red, Color.blue, Color.yellow, Color.green, Color.cyan
						};	//	버튼의 개수만큼 색상을 준비
	
	public MyCardLayOut(String title)
	{
		super(title);	//	Frame 클래스의 생성자에 제목 전달
		
			//	카드 레이아웃을 만들기
			this.cardlayout = new CardLayout();
			
			//	카드 레이아웃을 Frame에 추가
			super.setLayout(cardlayout);
			
			//	패널을 교체하는 방식으로 구현한다.
			//	패널에 버튼을 추가한다. 한 패널 당 버튼 하나를 할당
			this.panel = new Panel[this.ButtonCnt];		//	패널 5개 할당
			this.button = new Button[this.ButtonCnt];	//	버튼 5개 할당
			
			//	버튼을 만들어서 패널에 추가한 다음에 이 패널을 Frame에 붙인다.
			for(int i = 0; i < this.panel.length; i++)
			{
				this.panel[i] = new Panel();
				
				//	패널 생성 후, 관련 설정을 해야 한다.
				this.panel[i].setBackground(this.color[i]);
				
				this.button[i] = new Button("button"+(i+1));
				
				this.panel[i].add(this.button[i]);
				
				super.add(this.panel[i]);
			}
			
			//	이벤트  등록. 버튼이 클릭이 되면 다음 카드로 변경
			for(int i = 0; i < this.button.length; i++)
			{
				this.button[i].addActionListener(
						new ActionListener()//	익명인데, ActionListener는 인터페이스이므로,
						{					//	인스턴스를 하기 위해서는 추상 메소드인 actionPerformed의 재정의 필요
							@Override
							public void actionPerformed(ActionEvent e)	//	actionPerformed함수 재정의
							{
								if (e.getSource().equals(button[ButtonCnt-1]))	//	5번 버튼이 눌리면 종료
									System.exit(0);
								
								//	매개변수에는 Frame을 상속받는 클래스가 들어가야 하는데,
								//	그냥 this를 적으면 ActionListener 클래스를 의미하므로
								//	다른 방식을 찾아야 하는데, 이는 곧, MyCardLayOut 클래스를 통해 지정해준다.
								//	next함수의 매개변수는 Frame 객체 혹은 Frame객체를 상속 받은 객체를 요구한다.
								//	그래서, Frame 객체 혹은 Frame객체를 상속 받은 객체를 매개변수로 넣어줘야 한다.
								cardlayout.next(MyCardLayOut.this);
							
							}
						});
			}
			
			super.setSize(500, 500);	//	윈도우 창의 크기 조절
			super.setVisible(true);		//	윈도우 창을 눈에 보이게 설정
	}

	public void DisplayCard()
	{
		try
		{
			Thread.sleep(5000);
			
			for(int i = 0; i < this.panel.length; i++) 
			{
				//	매개변수는 제어할 클래스이다. 즉, Frame이다. 
				//	현재의 클래스가 Frame을 상속 받았으므로 this를 매개변수로 준다.
				this.cardlayout.next(this);	//	보여지는 카드를 바꾸는 함수
				//	Sleep함수를 쓰기 위해서 try catch블록을 선언해야 한다.
				Thread.sleep(2000);	//	2000ms는 2초를 의미
			}
		}
		catch(InterruptedException ie){}
	}
}

public class MakeCardLayOut {
	public static void main(String[] args) {
		MyCardLayOut ml = new MyCardLayOut("카드 레이아웃 만들기"); 
		//	ml.DisplayCard();
	}
}

